Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.poi.xssf.streaming
Class SXSSFWorkbook

    java.lang.Object
      org.apache.poi.xssf.streaming.SXSSFWorkbook

All Implemented Interfaces:
  org.apache.poi.ss.usermodel.Workbook

    public class SXSSFWorkbook

extends java.lang.Object
implements org.apache.poi.ss.usermodel.Workbook

Streaming version of XSSFWorkbook implementing the "BigGridDemo" strategy.

Author:
  Alex Geller, Four J's Development Tools

Field Summary
`static int` | `DEFAULT_WINDOW_SIZE` Specifies how many rows can be accessed at most via getRow().

Fields inherited from interface org.apache.poi.ss.usermodel.Workbook
`PICTURE_TYPE_DIB, PICTURE_TYPE_EMF, PICTURE_TYPE_JPEG, PICTURE_TYPE_PICT, PICTURE_TYPE_PNG, PICTURE_TYPE_WMF, SHEET_STATE_HIDDEN, SHEET_STATE_VERY_HIDDEN, SHEET_STATE_VISIBLE`

Constructor Summary
`SXSSFWorkbook()` Construct a new workbook
`SXSSFWorkbook(int rowAccessWindowSize)` Construct an empty workbook and specify the window for row access.
`SXSSFWorkbook(XSSFWorkbook workbook)` Construct a workbook from a template.
`SXSSFWorkbook(XSSFWorkbook workbook, int rowAccessWindowSize)` Constructs an workbook from an existing workbook.
`SXSSFWorkbook(XSSFWorkbook workbook, int rowAccessWindowSize, boolean compressTmpFiles)` Constructs an workbook from an existing workbook.

Method Summary
`int` | `addPicture(byte[] pictureData, int format)` Adds a picture to the workbook.
`void` | `addToolPack(org.apache.poi.ss.formula.udf.UDFFinder toopack)` Register a new toolpack in this workbook.
`org.apache.poi.ss.usermodel.Sheet` | `cloneSheet(int sheetNum)` Create an Sheet from an existing sheet in the Workbook.
`org.apache.poi.ss.usermodel.CellStyle` | `createCellStyle()` Create a new Cell style and add it to the workbook's style table
`org.apache.poi.ss.usermodel.DataFormat` | `createDataFormat()` Returns the instance of DataFormat for this workbook.
`org.apache.poi.ss.usermodel.Font` | `createFont()` Create a new Font and add it to the workbook's font table
`org.apache.poi.ss.usermodel.Name` | `createName()` Creates a new (uninitialised) defined name in this workbook
`org.apache.poi.ss.usermodel.Sheet` | `createSheet()` Sreate an Sheet for this Workbook, adds it to the sheets and returns the high level representation.
`org.apache.poi.ss.usermodel.Sheet` | `createSheet(java.lang.String sheetname)` Create an Sheet for this Workbook, adds it to the sheets and returns the high level representation.
`org.apache.poi.ss.usermodel.Font` | `findFont(short boldWeight, short color, short fontHeight, java.lang.String name, boolean italic, boolean strikeout, short typeOffset, byte underline)` Finds a font that matches the one with the supplied attributes
`int` | `getActiveSheetIndex()` Convenience method to get the active sheet.
`java.util.List` | `getAllPictures()` Gets all pictures from the Workbook.
`org.apache.poi.ss.usermodel.CellStyle` | `getCellStyleAt(short idx)` Get the cell style object at the given index
`org.apache.poi.ss.usermodel.CreationHelper` | `getCreationHelper()` Returns an object that handles instantiating concrete classes of the various instances one needs for HSSF and XSSF.
`int` | `getFirstVisibleTab()` Gets the first tab that is displayed in the list of tabs in excel.
`org.apache.poi.ss.usermodel.Font` | `getFontAt(short idx)` Get the font at the given index number
`boolean` | `getForceFormulaRecalculation()` Whether Excel will be asked to recalculate all formulas when the workbook is opened.
`org.apache.poi.ss.usermodel.Row.MissingCellPolicy` | `getMissingCellPolicy()` Retrieves the current policy on what to do when getting missing or blank cells from a row.
`org.apache.poi.ss.usermodel.Name` | `getName(java.lang.String name)`
`org.apache.poi.ss.usermodel.Name` | `getNameAt(int nameIndex)`
`int` | `getNameIndex(java.lang.String name)` Gets the defined name index by name Note: Excel defined names are case-insensitive and this method performs a case-insensitive search.
`short` | `getNumberOfFonts()` Get the number of fonts in the font table
`int` | `getNumberOfNames()`
`int` | `getNumberOfSheets()` Get the number of spreadsheets in the workbook
`short` | `getNumCellStyles()` Get the number of styles the workbook contains
`java.lang.String` | `getPrintArea(int sheetIndex)` Retrieves the reference for the printarea of the specified sheet, the sheet name is appended to the reference even if it was not specified.
`int` | `getRandomAccessWindowSize()`
`org.apache.poi.ss.usermodel.Sheet` | `getSheet(java.lang.String name)` Get sheet with the given name
`org.apache.poi.ss.usermodel.Sheet` | `getSheetAt(int index)` Get the Sheet object at the given index.
`int` | `getSheetIndex(org.apache.poi.ss.usermodel.Sheet sheet)` Returns the index of the given sheet
`int` | `getSheetIndex(java.lang.String name)` Returns the index of the sheet by his name
`java.lang.String` | `getSheetName(int sheet)` Set the sheet name
`XSSFWorkbook` | `getXSSFWorkbook()`
`boolean` | `isHidden()`
`boolean` | `isSheetHidden(int sheetIx)` Check whether a sheet is hidden.
`boolean` | `isSheetVeryHidden(int sheetIx)` Check whether a sheet is very hidden.
`void` | `removeName(int index)` Remove the defined name at the specified index
`void` | `removeName(java.lang.String name)` Remove a defined name by name
`void` | `removePrintArea(int sheetIndex)` Delete the printarea for the sheet specified
`void` | `removeSheetAt(int index)` Removes sheet at the given index
`void` | `setActiveSheet(int sheetIndex)` Convenience method to set the active sheet.
`void` | `setCompressTempFiles(boolean compress)` Set whether temp files should be compressed.
`void` | `setFirstVisibleTab(int sheetIndex)` Sets the first tab that is displayed in the list of tabs in excel.
`void` | `setForceFormulaRecalculation(boolean value)` Whether the application shall perform a full recalculation when the workbook is opened.
`void` | `setHidden(boolean hiddenFlag)`
`void` | `setMissingCellPolicy(org.apache.poi.ss.usermodel.Row.MissingCellPolicy missingCellPolicy)` Sets the policy on what to do when getting missing or blank cells from a row.
`void` | `setPrintArea(int sheetIndex, int startColumn, int endColumn, int startRow, int endRow)` For the Convenience of Java Programmers maintaining pointers.
`void` | `setPrintArea(int sheetIndex, java.lang.String reference)` Sets the printarea for the sheet provided
`void` | `setRepeatingRowsAndColumns(int sheetIndex, int startColumn, int endColumn, int startRow, int endRow)` Sets the repeating rows and columns for a sheet (as found in File->PageSetup->Sheet).
`void` | `setSelectedTab(int index)` Sets the tab whose data is actually seen when the sheet is opened.
`void` | `setSheetHidden(int sheetIx, boolean hidden)` Hide or unhide a sheet
`void` | `setSheetHidden(int sheetIx, int hidden)` Hide or unhide a sheet.
`void` | `setSheetName(int sheet, java.lang.String name)` Set the sheet name.
`void` | `setSheetOrder(java.lang.String sheetname, int pos)` Sets the order of appearance for a given sheet.
`void` | `write(java.io.OutputStream stream)` Write out this workbook to an Outputstream.

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### DEFAULT_WINDOW_SIZE

    public static final int DEFAULT_WINDOW_SIZE

  Specifies how many rows can be accessed at most via getRow(). When a new node is created via createRow() and the total number of unflushed records would exeed the specified value, then the row with the lowest index value is flushed and cannot be accessed via getRow() anymore.

  See Also:
    Constant Field Values

Constructor Detail

### SXSSFWorkbook

    public SXSSFWorkbook()

  Construct a new workbook

### SXSSFWorkbook

    public SXSSFWorkbook(XSSFWorkbook workbook)

  Construct a workbook from a template.

  There are three use-cases to use SXSSFWorkbook(XSSFWorkbook) :

  1. Append new sheets to existing workbooks. You can open existing workbook from a file or create on the fly with XSSF.
  2. Append rows to existing sheets. The row number MUST be greater than max(rownum) in the template sheet.
  3. Use existing workbook as a template and re-use global objects such as cell styles, formats, images, etc.
  All three use cases can work in a combination. What is not supported:
  - Access initial cells and rows in the template. After constructing SXSSFWorkbook(XSSFWorkbook) all internal windows are empty and SXSSFSheet@getRow and SXSSFRow#getCell return null.
  - Override existing cells and rows. The API silently allows that but the output file is invalid and Excel cannot read it.

  Parameters:
    `workbook` - the template workbook

### SXSSFWorkbook

    public SXSSFWorkbook(XSSFWorkbook workbook,
                         int rowAccessWindowSize)

  Constructs an workbook from an existing workbook.

  When a new node is created via createRow() and the total number of unflushed records would exceed the specified value, then the row with the lowest index value is flushed and cannot be accessed via getRow() anymore.

  A value of -1 indicates unlimited access. In this case all records that have not been flushed by a call to flush() are available for random access.

  A value of 0 is not allowed because it would flush any newly created row without having a chance to specify any cells.

  Parameters:
    `rowAccessWindowSize` -

### SXSSFWorkbook

    public SXSSFWorkbook(XSSFWorkbook workbook,
                         int rowAccessWindowSize,
                         boolean compressTmpFiles)

  Constructs an workbook from an existing workbook.

  When a new node is created via createRow() and the total number of unflushed records would exceed the specified value, then the row with the lowest index value is flushed and cannot be accessed via getRow() anymore.

  A value of -1 indicates unlimited access. In this case all records that have not been flushed by a call to flush() are available for random access.

  A value of 0 is not allowed because it would flush any newly created row without having a chance to specify any cells.

  Parameters:
    `rowAccessWindowSize` -
    `compressTmpFiles` - whether to use gzip compression for temporary files

### SXSSFWorkbook

    public SXSSFWorkbook(int rowAccessWindowSize)

  Construct an empty workbook and specify the window for row access.

  When a new node is created via createRow() and the total number of unflushed records would exceed the specified value, then the row with the lowest index value is flushed and cannot be accessed via getRow() anymore.

  A value of -1 indicates unlimited access. In this case all records that have not been flushed by a call to flush() are available for random access.

  A value of 0 is not allowed because it would flush any newly created row without having a chance to specify any cells.

  Parameters:
    `rowAccessWindowSize` -

Method Detail

### getRandomAccessWindowSize

    public int getRandomAccessWindowSize()

### setCompressTempFiles

    public void setCompressTempFiles(boolean compress)

  Set whether temp files should be compressed.

  SXSSF writes sheet data in temporary files (a temp file per-sheet) and the size of these temp files can grow to to a very large size, e.g. for a 20 MB csv data the size of the temp xml file become few GB large. If the "compress" flag is set to `true` then the temporary XML is gzipped.

  Please note the the "compress" option may cause performance penalty.

  Parameters:
    `compress` - whether to compress temp files

### getXSSFWorkbook

    public XSSFWorkbook getXSSFWorkbook()

### getActiveSheetIndex

    public int getActiveSheetIndex()

  Convenience method to get the active sheet. The active sheet is is the sheet which is currently displayed when the workbook is viewed in Excel. 'Selected' sheet(s) is a distinct concept.

  Specified by:
    `getActiveSheetIndex` in interface `org.apache.poi.ss.usermodel.Workbook`
  Returns:
    the index of the active sheet (0-based)

### setActiveSheet

    public void setActiveSheet(int sheetIndex)

  Convenience method to set the active sheet. The active sheet is is the sheet which is currently displayed when the workbook is viewed in Excel. 'Selected' sheet(s) is a distinct concept.

  Specified by:
    `setActiveSheet` in interface `org.apache.poi.ss.usermodel.Workbook`
  Parameters:
    `sheetIndex` - index of the active sheet (0-based)

### getFirstVisibleTab

    public int getFirstVisibleTab()

  Gets the first tab that is displayed in the list of tabs in excel.

  Specified by:
    `getFirstVisibleTab` in interface `org.apache.poi.ss.usermodel.Workbook`
  Returns:
    the first tab that to display in the list of tabs (0-based).

### setFirstVisibleTab

    public void setFirstVisibleTab(int sheetIndex)

  Sets the first tab that is displayed in the list of tabs in excel.

  Specified by:
    `setFirstVisibleTab` in interface `org.apache.poi.ss.usermodel.Workbook`
  Parameters:
    `sheetIndex` - the first tab that to display in the list of tabs (0-based)

### setSheetOrder

    public void setSheetOrder(java.lang.String sheetname,
                              int pos)

  Sets the order of appearance for a given sheet.

  Specified by:
    `setSheetOrder` in interface `org.apache.poi.ss.usermodel.Workbook`
  Parameters:
    `sheetname` - the name of the sheet to reorder
    `pos` - the position that we want to insert the sheet into (0 based)

### setSelectedTab

    public void setSelectedTab(int index)

  Sets the tab whose data is actually seen when the sheet is opened. This may be different from the "selected sheet" since excel seems to allow you to show the data of one sheet when another is seen "selected" in the tabs (at the bottom).

  Specified by:
    `setSelectedTab` in interface `org.apache.poi.ss.usermodel.Workbook`
  Parameters:
    `index` - the index of the sheet to select (0 based)
  See Also:
    `Sheet.setSelected(boolean)`

### setSheetName

    public void setSheetName(int sheet,
                             java.lang.String name)

  Set the sheet name.

  Specified by:
    `setSheetName` in interface `org.apache.poi.ss.usermodel.Workbook`
  Parameters:
    `sheet` - number (0 based)
  Throws:
    `java.lang.IllegalArgumentException` - if the name is greater than 31 chars or contains `/\?*[]`

### getSheetName

    public java.lang.String getSheetName(int sheet)

  Set the sheet name

  Specified by:
    `getSheetName` in interface `org.apache.poi.ss.usermodel.Workbook`
  Parameters:
    `sheet` - sheet number (0 based)
  Returns:
    Sheet name

### getSheetIndex

    public int getSheetIndex(java.lang.String name)

  Returns the index of the sheet by his name

  Specified by:
    `getSheetIndex` in interface `org.apache.poi.ss.usermodel.Workbook`
  Parameters:
    `name` - the sheet name
  Returns:
    index of the sheet (0 based)

### getSheetIndex

    public int getSheetIndex(org.apache.poi.ss.usermodel.Sheet sheet)

  Returns the index of the given sheet

  Specified by:
    `getSheetIndex` in interface `org.apache.poi.ss.usermodel.Workbook`
  Parameters:
    `sheet` - the sheet to look up
  Returns:
    index of the sheet (0 based)

### createSheet

    public org.apache.poi.ss.usermodel.Sheet createSheet()

  Sreate an Sheet for this Workbook, adds it to the sheets and returns the high level representation. Use this to create new sheets.

  Specified by:
    `createSheet` in interface `org.apache.poi.ss.usermodel.Workbook`
  Returns:
    Sheet representing the new sheet.

### createSheet

    public org.apache.poi.ss.usermodel.Sheet createSheet(java.lang.String sheetname)

  Create an Sheet for this Workbook, adds it to the sheets and returns the high level representation. Use this to create new sheets.

  Specified by:
    `createSheet` in interface `org.apache.poi.ss.usermodel.Workbook`
  Parameters:
    `sheetname` - sheetname to set for the sheet.
  Returns:
    Sheet representing the new sheet.
  Throws:
    `java.lang.IllegalArgumentException` - if the name is greater than 31 chars or contains `/\?*[]`

### cloneSheet

    public org.apache.poi.ss.usermodel.Sheet cloneSheet(int sheetNum)

  Create an Sheet from an existing sheet in the Workbook.

  Specified by:
    `cloneSheet` in interface `org.apache.poi.ss.usermodel.Workbook`
  Returns:
    Sheet representing the cloned sheet.

### getNumberOfSheets

    public int getNumberOfSheets()

  Get the number of spreadsheets in the workbook

  Specified by:
    `getNumberOfSheets` in interface `org.apache.poi.ss.usermodel.Workbook`
  Returns:
    the number of sheets

### getSheetAt

    public org.apache.poi.ss.usermodel.Sheet getSheetAt(int index)

  Get the Sheet object at the given index.

  Specified by:
    `getSheetAt` in interface `org.apache.poi.ss.usermodel.Workbook`
  Parameters:
    `index` - of the sheet number (0-based physical & logical)
  Returns:
    Sheet at the provided index

### getSheet

    public org.apache.poi.ss.usermodel.Sheet getSheet(java.lang.String name)

  Get sheet with the given name

  Specified by:
    `getSheet` in interface `org.apache.poi.ss.usermodel.Workbook`
  Parameters:
    `name` - of the sheet
  Returns:
    Sheet with the name provided or `null` if it does not exist

### removeSheetAt

    public void removeSheetAt(int index)

  Removes sheet at the given index

  Specified by:
    `removeSheetAt` in interface `org.apache.poi.ss.usermodel.Workbook`
  Parameters:
    `index` - of the sheet to remove (0-based)

### setRepeatingRowsAndColumns

    public void setRepeatingRowsAndColumns(int sheetIndex,
                                           int startColumn,
                                           int endColumn,
                                           int startRow,
                                           int endRow)

  Sets the repeating rows and columns for a sheet (as found in File->PageSetup->Sheet). This is function is included in the workbook because it creates/modifies name records which are stored at the workbook level.

  To set just repeating columns:

        workbook.setRepeatingRowsAndColumns(0,0,1,-1-1);

  To set just repeating rows:

        workbook.setRepeatingRowsAndColumns(0,-1,-1,0,4);

  To remove all repeating rows and columns for a sheet.

        workbook.setRepeatingRowsAndColumns(0,-1,-1,-1,-1);

  Specified by:
    `setRepeatingRowsAndColumns` in interface `org.apache.poi.ss.usermodel.Workbook`
  Parameters:
    `sheetIndex` - 0 based index to sheet.
    `startColumn` - 0 based start of repeating columns.
    `endColumn` - 0 based end of repeating columns.
    `startRow` - 0 based start of repeating rows.
    `endRow` - 0 based end of repeating rows.

### createFont

    public org.apache.poi.ss.usermodel.Font createFont()

  Create a new Font and add it to the workbook's font table

  Specified by:
    `createFont` in interface `org.apache.poi.ss.usermodel.Workbook`
  Returns:
    new font object

### findFont

    public org.apache.poi.ss.usermodel.Font findFont(short boldWeight,
                                                     short color,
                                                     short fontHeight,
                                                     java.lang.String name,
                                                     boolean italic,
                                                     boolean strikeout,
                                                     short typeOffset,
                                                     byte underline)

  Finds a font that matches the one with the supplied attributes

  Specified by:
    `findFont` in interface `org.apache.poi.ss.usermodel.Workbook`
  Returns:
    the font with the matched attributes or `null`

### getNumberOfFonts

    public short getNumberOfFonts()

  Get the number of fonts in the font table

  Specified by:
    `getNumberOfFonts` in interface `org.apache.poi.ss.usermodel.Workbook`
  Returns:
    number of fonts

### getFontAt

    public org.apache.poi.ss.usermodel.Font getFontAt(short idx)

  Get the font at the given index number

  Specified by:
    `getFontAt` in interface `org.apache.poi.ss.usermodel.Workbook`
  Parameters:
    `idx` - index number (0-based)
  Returns:
    font at the index

### createCellStyle

    public org.apache.poi.ss.usermodel.CellStyle createCellStyle()

  Create a new Cell style and add it to the workbook's style table

  Specified by:
    `createCellStyle` in interface `org.apache.poi.ss.usermodel.Workbook`
  Returns:
    the new Cell Style object

### getNumCellStyles

    public short getNumCellStyles()

  Get the number of styles the workbook contains

  Specified by:
    `getNumCellStyles` in interface `org.apache.poi.ss.usermodel.Workbook`
  Returns:
    count of cell styles

### getCellStyleAt

    public org.apache.poi.ss.usermodel.CellStyle getCellStyleAt(short idx)

  Get the cell style object at the given index

  Specified by:
    `getCellStyleAt` in interface `org.apache.poi.ss.usermodel.Workbook`
  Parameters:
    `idx` - index within the set of styles (0-based)
  Returns:
    CellStyle object at the index

### write

    public void write(java.io.OutputStream stream)
               throws java.io.IOException

  Write out this workbook to an Outputstream.

  Specified by:
    `write` in interface `org.apache.poi.ss.usermodel.Workbook`
  Parameters:
    `stream` - - the java OutputStream you wish to write to
  Throws:
    `java.io.IOException` - if anything can't be written.

### getNumberOfNames

    public int getNumberOfNames()

  Specified by:
    `getNumberOfNames` in interface `org.apache.poi.ss.usermodel.Workbook`
  Returns:
    the total number of defined names in this workbook

### getName

    public org.apache.poi.ss.usermodel.Name getName(java.lang.String name)

  Specified by:
    `getName` in interface `org.apache.poi.ss.usermodel.Workbook`
  Parameters:
    `name` - the name of the defined name
  Returns:
    the defined name with the specified name. `null` if not found.

### getNameAt

    public org.apache.poi.ss.usermodel.Name getNameAt(int nameIndex)

  Specified by:
    `getNameAt` in interface `org.apache.poi.ss.usermodel.Workbook`
  Parameters:
    `nameIndex` - position of the named range (0-based)
  Returns:
    the defined name at the specified index
  Throws:
    `java.lang.IllegalArgumentException` - if the supplied index is invalid

### createName

    public org.apache.poi.ss.usermodel.Name createName()

  Creates a new (uninitialised) defined name in this workbook

  Specified by:
    `createName` in interface `org.apache.poi.ss.usermodel.Workbook`
  Returns:
    new defined name object

### getNameIndex

    public int getNameIndex(java.lang.String name)

  Gets the defined name index by name
  Note: Excel defined names are case-insensitive and this method performs a case-insensitive search.

  Specified by:
    `getNameIndex` in interface `org.apache.poi.ss.usermodel.Workbook`
  Parameters:
    `name` - the name of the defined name
  Returns:
    zero based index of the defined name. `-1` if not found.

### removeName

    public void removeName(int index)

  Remove the defined name at the specified index

  Specified by:
    `removeName` in interface `org.apache.poi.ss.usermodel.Workbook`
  Parameters:
    `index` - named range index (0 based)

### removeName

    public void removeName(java.lang.String name)

  Remove a defined name by name

  Specified by:
    `removeName` in interface `org.apache.poi.ss.usermodel.Workbook`
  Parameters:
    `name` - the name of the defined name

### setPrintArea

    public void setPrintArea(int sheetIndex,
                             java.lang.String reference)

  Sets the printarea for the sheet provided

  i.e. Reference = $A$1:$B$2

  Specified by:
    `setPrintArea` in interface `org.apache.poi.ss.usermodel.Workbook`
  Parameters:
    `sheetIndex` - Zero-based sheet index (0 Represents the first sheet to keep consistent with java)
    `reference` - Valid name Reference for the Print Area

### setPrintArea

    public void setPrintArea(int sheetIndex,
                             int startColumn,
                             int endColumn,
                             int startRow,
                             int endRow)

  For the Convenience of Java Programmers maintaining pointers.

  Specified by:
    `setPrintArea` in interface `org.apache.poi.ss.usermodel.Workbook`
  Parameters:
    `sheetIndex` - Zero-based sheet index (0 = First Sheet)
    `startColumn` - Column to begin printarea
    `endColumn` - Column to end the printarea
    `startRow` - Row to begin the printarea
    `endRow` - Row to end the printarea
  See Also:
    `setPrintArea(int, String)`

### getPrintArea

    public java.lang.String getPrintArea(int sheetIndex)

  Retrieves the reference for the printarea of the specified sheet, the sheet name is appended to the reference even if it was not specified.

  Specified by:
    `getPrintArea` in interface `org.apache.poi.ss.usermodel.Workbook`
  Parameters:
    `sheetIndex` - Zero-based sheet index (0 Represents the first sheet to keep consistent with java)
  Returns:
    String Null if no print area has been defined

### removePrintArea

    public void removePrintArea(int sheetIndex)

  Delete the printarea for the sheet specified

  Specified by:
    `removePrintArea` in interface `org.apache.poi.ss.usermodel.Workbook`
  Parameters:
    `sheetIndex` - Zero-based sheet index (0 = First Sheet)

### getMissingCellPolicy

    public org.apache.poi.ss.usermodel.Row.MissingCellPolicy getMissingCellPolicy()

  Retrieves the current policy on what to do when getting missing or blank cells from a row.

  The default is to return blank and null cells. `Row.MissingCellPolicy`

  Specified by:
    `getMissingCellPolicy` in interface `org.apache.poi.ss.usermodel.Workbook`

### setMissingCellPolicy

    public void setMissingCellPolicy(org.apache.poi.ss.usermodel.Row.MissingCellPolicy missingCellPolicy)

  Sets the policy on what to do when getting missing or blank cells from a row. This will then apply to all calls to `Row.getCell(int)`. See `Row.MissingCellPolicy`

  Specified by:
    `setMissingCellPolicy` in interface `org.apache.poi.ss.usermodel.Workbook`

### createDataFormat

    public org.apache.poi.ss.usermodel.DataFormat createDataFormat()

  Returns the instance of DataFormat for this workbook.

  Specified by:
    `createDataFormat` in interface `org.apache.poi.ss.usermodel.Workbook`
  Returns:
    the DataFormat object

### addPicture

    public int addPicture(byte[] pictureData,
                          int format)

  Adds a picture to the workbook.

  Specified by:
    `addPicture` in interface `org.apache.poi.ss.usermodel.Workbook`
  Parameters:
    `pictureData` - The bytes of the picture
    `format` - The format of the picture.
  Returns:
    the index to this picture (1 based).
  See Also:
    `Workbook.PICTURE_TYPE_EMF`, `Workbook.PICTURE_TYPE_WMF`, `Workbook.PICTURE_TYPE_PICT`, `Workbook.PICTURE_TYPE_JPEG`, `Workbook.PICTURE_TYPE_PNG`, `Workbook.PICTURE_TYPE_DIB`

### getAllPictures

    public java.util.List getAllPictures()

  Gets all pictures from the Workbook.

  Specified by:
    `getAllPictures` in interface `org.apache.poi.ss.usermodel.Workbook`
  Returns:
    the list of pictures (a list of `PictureData` objects.)

### getCreationHelper

    public org.apache.poi.ss.usermodel.CreationHelper getCreationHelper()

  Returns an object that handles instantiating concrete classes of the various instances one needs for HSSF and XSSF.

  Specified by:
    `getCreationHelper` in interface `org.apache.poi.ss.usermodel.Workbook`

### isHidden

    public boolean isHidden()

  Specified by:
    `isHidden` in interface `org.apache.poi.ss.usermodel.Workbook`
  Returns:
    `false` if this workbook is not visible in the GUI

### setHidden

    public void setHidden(boolean hiddenFlag)

  Specified by:
    `setHidden` in interface `org.apache.poi.ss.usermodel.Workbook`
  Parameters:
    `hiddenFlag` - pass `false` to make the workbook visible in the GUI

### isSheetHidden

    public boolean isSheetHidden(int sheetIx)

  Check whether a sheet is hidden.

  Note that a sheet could instead be set to be very hidden, which is different (`isSheetVeryHidden(int)`)

  Specified by:
    `isSheetHidden` in interface `org.apache.poi.ss.usermodel.Workbook`
  Parameters:
    `sheetIx` - Number
  Returns:
    `true` if sheet is hidden

### isSheetVeryHidden

    public boolean isSheetVeryHidden(int sheetIx)

  Check whether a sheet is very hidden.

  This is different from the normal hidden status (`isSheetHidden(int)`)

  Specified by:
    `isSheetVeryHidden` in interface `org.apache.poi.ss.usermodel.Workbook`
  Parameters:
    `sheetIx` - sheet index to check
  Returns:
    `true` if sheet is very hidden

### setSheetHidden

    public void setSheetHidden(int sheetIx,
                               boolean hidden)

  Hide or unhide a sheet

  Specified by:
    `setSheetHidden` in interface `org.apache.poi.ss.usermodel.Workbook`
  Parameters:
    `sheetIx` - the sheet index (0-based)
    `hidden` - True to mark the sheet as hidden, false otherwise

### setSheetHidden

    public void setSheetHidden(int sheetIx,
                               int hidden)

  Hide or unhide a sheet.
  - 0 - visible.
  - 1 - hidden.
  - 2 - very hidden.

  Specified by:
    `setSheetHidden` in interface `org.apache.poi.ss.usermodel.Workbook`
  Parameters:
    `sheetIx` - the sheet index (0-based)
    `hidden` - one of the following `Workbook` constants: `Workbook.SHEET_STATE_VISIBLE`, `Workbook.SHEET_STATE_HIDDEN`, or `Workbook.SHEET_STATE_VERY_HIDDEN`.
  Throws:
    `java.lang.IllegalArgumentException` - if the supplied sheet index or state is invalid

### addToolPack

    public void addToolPack(org.apache.poi.ss.formula.udf.UDFFinder toopack)

  Register a new toolpack in this workbook.

  Specified by:
    `addToolPack` in interface `org.apache.poi.ss.usermodel.Workbook`
  Parameters:
    `toopack` - the toolpack to register

### setForceFormulaRecalculation

    public void setForceFormulaRecalculation(boolean value)

  Whether the application shall perform a full recalculation when the workbook is opened.

  Typically you want to force formula recalculation when you modify cell formulas or values of a workbook previously created by Excel. When set to 0, this flag will tell Excel that it needs to recalculate all formulas in the workbook the next time the file is opened.

  Specified by:
    `setForceFormulaRecalculation` in interface `org.apache.poi.ss.usermodel.Workbook`
  Parameters:
    `value` - true if the application will perform a full recalculation of workbook values when the workbook is opened
  Since:
    3.8

### getForceFormulaRecalculation

    public boolean getForceFormulaRecalculation()

  Whether Excel will be asked to recalculate all formulas when the workbook is opened.

  Specified by:
    `getForceFormulaRecalculation` in interface `org.apache.poi.ss.usermodel.Workbook`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD